<?php

namespace Importacao\Logic\Integracao\Mastermaq\Classes;

use \Importacao\Logic\Integracao\Mastermaq\Classes\Migracao;

use \Importacao\Logic\Integracao\Mastermaq\Classes\Entities\Estrutura;

/**
 * Description of GeraEstrutura
 *
 * @author matheussilva
 */
class GeraEstruturaSindicato extends Migracao {
    
    public function __construct($path) {
        parent::__construct($path);
        $this->file_name = 'Estrutura_SIND';
        $this->setColumns();
    }

    public function createInfo($info) {
        foreach ($info as $reg) {
            
            $estrutura = new Estrutura();
            
            $estrutura->setTipo_de_estrutura(10);
            $estrutura->setInicio_de_vigencia('20000101');
            $estrutura->setNm_estrutura($reg['SINDICATO']);
            $estrutura->setMes_competencia(self::COMPETENCIA);
            $estrutura->setCnpj($reg['CGC']);
            $estrutura->setRazao_social($reg['NOME']);
            $estrutura->setTp_endereco('PRINCIPAL');
            $estrutura->setEstado($reg['ESTADO']);
            $estrutura->setMunicipio($reg['CIDADE']);
            $estrutura->setEndereco($reg['ENDERECO']);
            $estrutura->setBairro($reg['BAIRRO']);
            $estrutura->setNr_cep($reg['CEP']);
            $estrutura->setNome_fantasia($reg['NOME']);
            $estrutura->setData_base_sindical($reg['DATA_BASE']);
            $estrutura->setCod_sindicato($reg['COD_ENTID']);
            $estrutura->setNome_da_estrutura($reg['NOME']);
            // $estrutura->setFim_de_vigencia($reg['TERMINO']);
            // $estrutura->setCei($reg['CGC_CEI']);
            // $estrutura->setNatureza_juridica($reg['NATJUR']);
            // $estrutura->setCodigo_cnae($reg['CNAE']);
            // $estrutura->setCodigo_fpas($reg['FPAS']);
            // $estrutura->setCodigo_caged($reg['CAGED_NUM']);
            // $estrutura->setOptante_simples($reg['SIMPLES']);
            // $estrutura->setParticipacao_pat($reg['PAT']);
            // $estrutura->setLogradouro($reg['LOGR']);
            // $estrutura->setCpf($reg['RESP_CPF']);
            // $estrutura->setTipo_de_estrutura($reg['']);
            // $estrutura->setTipo_de_empresa($reg['']);
            // $estrutura->setPais($reg['']);
            // $estrutura->setNumero($reg['']);
            // $estrutura->setReferencia_do_endereco($reg['']);
            

            $this->objects[] = $estrutura;	
            
        }
    }
    public function setColumns() {
        $this->columns[] = 'Tipo de Estrutura';
        $this->columns[] = 'Início de Vigência';
        $this->columns[] = 'Fim de Vigência';
        $this->columns[] = 'Nº Estrutura';
        $this->columns[] = 'Mês Competência';
        $this->columns[] = 'CNPJ';
        $this->columns[] = 'CEI';
        $this->columns[] = 'Razão Social';
        $this->columns[] = 'Natureza Jurídica';
        $this->columns[] = 'CNAE';
        $this->columns[] = 'FPAS';
        $this->columns[] = 'CAGED';
        $this->columns[] = 'Tipo de Empresa';
        $this->columns[] = 'Optante Simples';
        $this->columns[] = 'Participaçao PAT';
        $this->columns[] = 'Tp Endereço';
        $this->columns[] = 'Pais';
        $this->columns[] = 'Estado';
        $this->columns[] = 'Município';
        $this->columns[] = 'Logradouro';
        $this->columns[] = 'Endereço';
        $this->columns[] = 'Numero';
        $this->columns[] = 'Nome do Bairro';
        $this->columns[] = 'CEP';
        $this->columns[] = 'Referência do Endereço';
        $this->columns[] = 'Nome Fantasia';
        $this->columns[] = 'Nome Estrutura';
        $this->columns[] = 'CPF';
        $this->columns[] = 'Data Base Sindical';
        $this->columns[] = 'Cód Sindicato';
        
        
        

    }
}

?>
