/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CNPR                                                     */
/* Tabela : CONVPRODUTO                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 02/08/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CNPR
BEFORE INSERT OR UPDATE OR DELETE
ON CONVPRODUTO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCNPR := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.VRFATOCONVES,0) <> NVL(:NEW.VRFATOCONVES,0)) OR
         (NVL(:OLD.CDPRODUTO,0)    <> NVL(:NEW.CDPRODUTO,0))    OR
         (NVL(:OLD.SGUNIDADE,0)    <> NVL(:NEW.SGUNIDADE,0))  THEN
         :NEW.DTULTATUCNPR := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CONVPRODUTO', '', 'SGUNIDADE='||:OLD.SGUNIDADE||';CDPRODUTO='||:OLD.CDPRODUTO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CONVPRODUTO MODIFY DTULTATUCNPR DEFAULT SYSDATE
/
