/* Sistemas Integrados TECNISA

Nome: 8988_SUPTRGS_LOG_SUP_ITEMPEDEXOL.SQL

Descrio:
   Trigger para gravar o registro de alteraes na tabela PEDIDOEXOL.

Criao:
   18/08/2008 - Davidson Henrique Gontijo
*/
/* Tabela PEDIDOEXOL: Lanamento de Pedidos do OL */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela PEDIDOEXOL */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Lanamento de Pedidos do OL,
             utilizando a tabela Geral de Logs de Operaes */

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_SUP_ITEMPEDEXOL' AND
                 TYPE = 'TR' 		        AND
	              U.UID = O.UID             AND
	              U.NAME = USER)
DROP TRIGGER LOG_SUP_ITEMPEDEXOL
GO


CREATE  TRIGGER LOG_SUP_ITEMPEDEXOL
ON ITEMPEDEXOL
FOR INSERT, UPDATE, DELETE

AS
   DECLARE  @V_USUARIO   VARCHAR(40);
   DECLARE  @V_TIPO      VARCHAR(1);
   DECLARE  @V_ITPESQ    VARCHAR(80);
   DECLARE  @V_DESC      VARCHAR(1500);
   DECLARE  @V_DTOPER    DATETIME;

   /*VARIVEIS DO CURSOR C_CURSOR*/
   DECLARE @V_ID_COMANDO        VARCHAR(1) ;

   DECLARE @V_OLD_CDFILDEST           VARCHAR(4);
   DECLARE @V_OLD_CDFILLANC           VARCHAR(4);
   DECLARE @V_OLD_NRPEDEXOL           VARCHAR(10);
   DECLARE @V_OLD_CDMARCA             VARCHAR(5);
   DECLARE @V_OLD_CDPRODUTO           VARCHAR(10);
   DECLARE @V_OLD_DTPROGENPEOL        DATETIME;
   DECLARE @V_OLD_CDOPERBAIXA         VARCHAR(12);
   DECLARE @V_OLD_DTBAIXTMPEOL        DATETIME
   DECLARE @V_OLD_QTPROGENPEOL        FLOAT;
   DECLARE @V_OLD_IDBAIXENPEOL        VARCHAR(2);
   DECLARE @V_OLD_IDBAIXAOLSAI        VARCHAR(2);
   DECLARE @V_OLD_DTEFETENPEOL        DATETIME;
   DECLARE @V_OLD_QTEFETENPEOL        FLOAT;
   DECLARE @V_OLD_DTPROGEMBARQ        DATETIME;
   DECLARE @V_OLD_QTATENDPEDOL        FLOAT;
   DECLARE @V_OLD_VRPBRUTOPEDOL       FLOAT;
   DECLARE @V_OLD_VRPLIQUIPEDOL       FLOAT;
   DECLARE @V_OLD_IDITMPEDOLBLOQ      VARCHAR(1);
   DECLARE @V_OLD_CDOPERBLOQITM       VARCHAR(12);
   DECLARE @V_OLD_CDLOTENVITOL        VARCHAR(10);
   DECLARE @V_OLD_CDOPERLOTEOL        VARCHAR(12);
   DECLARE @V_OLD_IDITEMAJUSTE        VARCHAR(1);
   DECLARE @V_OLD_CDPRODORIGPEDOL    VARCHAR(20);
   DECLARE @V_OLD_QTORIGPRODPED      FLOAT;

   DECLARE @V_NEW_CDFILDEST          VARCHAR(4);
   DECLARE @V_NEW_CDFILLANC          VARCHAR(4);
   DECLARE @V_NEW_NRPEDEXOL          VARCHAR(10);
   DECLARE @V_NEW_CDMARCA            VARCHAR(5);
   DECLARE @V_NEW_CDPRODUTO          VARCHAR(10);
   DECLARE @V_NEW_DTPROGENPEOL       DATETIME;
   DECLARE @V_NEW_CDOPERBAIXA        VARCHAR(12);
   DECLARE @V_NEW_DTBAIXTMPEOL       DATETIME;
   DECLARE @V_NEW_QTPROGENPEOL       FLOAT;
   DECLARE @V_NEW_IDBAIXENPEOL       VARCHAR(2);
   DECLARE @V_NEW_IDBAIXAOLSAI       VARCHAR(2);
   /*DECLARE @V_NEW_TXOBSITMPEOL       VARCHAR(2000);*/
   DECLARE @V_NEW_DTEFETENPEOL       DATETIME;
   DECLARE @V_NEW_QTEFETENPEOL       FLOAT;
   DECLARE @V_NEW_DTPROGEMBARQ       DATETIME;
   DECLARE @V_NEW_QTATENDPEDOL       FLOAT;
   DECLARE @V_NEW_VRPBRUTOPEDOL      FLOAT;
   DECLARE @V_NEW_VRPLIQUIPEDOL      FLOAT;
   DECLARE @V_NEW_IDITMPEDOLBLOQ     VARCHAR(1);
   DECLARE @V_NEW_CDOPERBLOQITM      VARCHAR(12);
   DECLARE @V_NEW_CDLOTENVITOL       VARCHAR(10);
   DECLARE @V_NEW_CDOPERLOTEOL       VARCHAR(12);
   DECLARE @V_NEW_IDITEMAJUSTE       VARCHAR(1);
   DECLARE @V_NEW_CDPRODORIGPEDOL    VARCHAR(20);
   DECLARE @V_NEW_QTORIGPRODPED      FLOAT;

BEGIN

   SET @V_DESC     = '';
   SET @V_TIPO     = '0';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, ' ');

   DECLARE C_CURSOR CURSOR FOR
      SELECT
             'D' IDCOMANDO,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              NULL,
              DELETED.CDFILDEST,
              DELETED.CDFILLANC,
              DELETED.NRPEDEXOL,
              DELETED.CDMARCA,
              DELETED.CDPRODUTO,
              DELETED.DTPROGENPEOL,
              DELETED.CDOPERBAIXA,
              DELETED.DTBAIXTMPEOL,
              DELETED.QTPROGENPEOL,
              DELETED.IDBAIXENPEOL,
              DELETED.IDBAIXAOLSAI,
              DELETED.DTEFETENPEOL,
              DELETED.QTEFETENPEOL,
              DELETED.DTPROGEMBARQ,
              DELETED.QTATENDPEDOL,
              DELETED.VRPBRUTOPEDOL,
              DELETED.IDITMPEDOLBLOQ,
              DELETED.CDOPERBLOQITM,
              DELETED.CDLOTENVITOL,
              DELETED.CDOPERLOTEOL,
              DELETED.IDITEMAJUSTE,
              DELETED.VRPLIQUIPEDOL,
              DELETED.CDPRODORIGPEDOL,
              DELETED.QTORIGPRODPED
      FROM
         DELETED
       WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
            'U' IDCOMANDO,
             INSERTED.CDFILDEST,
             INSERTED.CDFILLANC,
             INSERTED.NRPEDEXOL,
             INSERTED.CDMARCA,
             INSERTED.CDPRODUTO,
             INSERTED.DTPROGENPEOL,
             INSERTED.CDOPERBAIXA,
             INSERTED.DTBAIXTMPEOL,
             INSERTED.QTPROGENPEOL,
             INSERTED.IDBAIXENPEOL,
             INSERTED.IDBAIXAOLSAI,
             INSERTED.DTEFETENPEOL,
             INSERTED.QTEFETENPEOL,
             INSERTED.DTPROGEMBARQ,
             INSERTED.QTATENDPEDOL,
             INSERTED.VRPBRUTOPEDOL,
             INSERTED.IDITMPEDOLBLOQ,
             INSERTED.CDOPERBLOQITM,
             INSERTED.CDLOTENVITOL,
             INSERTED.CDOPERLOTEOL,
             INSERTED.IDITEMAJUSTE,
             INSERTED.VRPLIQUIPEDOL,
             INSERTED.CDPRODORIGPEDOL,
             INSERTED.QTORIGPRODPED,
             DELETED.CDFILDEST,
             DELETED.CDFILLANC,
             DELETED.NRPEDEXOL,
             DELETED.CDMARCA,
             DELETED.CDPRODUTO,
             DELETED.DTPROGENPEOL,
             DELETED.CDOPERBAIXA,
             DELETED.DTBAIXTMPEOL,
             DELETED.QTPROGENPEOL,
             DELETED.IDBAIXENPEOL,
             DELETED.IDBAIXAOLSAI,
             DELETED.DTEFETENPEOL,
             DELETED.QTEFETENPEOL,
             DELETED.DTPROGEMBARQ,
             DELETED.QTATENDPEDOL,
             DELETED.VRPBRUTOPEDOL,
             DELETED.IDITMPEDOLBLOQ,
             DELETED.CDOPERBLOQITM,
             DELETED.CDLOTENVITOL,
             DELETED.CDOPERLOTEOL,
             DELETED.IDITEMAJUSTE,
             DELETED.VRPLIQUIPEDOL,
             DELETED.CDPRODORIGPEDOL,
             DELETED.QTORIGPRODPED

        FROM
             INSERTED,
             DELETED
       WHERE
             INSERTED.CDFILDEST    =  DELETED.CDFILDEST     AND
             INSERTED.CDFILLANC    =  DELETED.CDFILLANC     AND
             INSERTED.NRPEDEXOL    =  DELETED.NRPEDEXOL     AND
             INSERTED.CDMARCA      =  DELETED.CDMARCA       AND
             INSERTED.CDPRODUTO    =  DELETED.CDPRODUTO     AND
             INSERTED.DTPROGENPEOL =  DELETED.DTPROGENPEOL

      UNION ALL

      SELECT
             'I' IDCOMANDO,
             INSERTED.CDFILDEST,
             INSERTED.CDFILLANC,
             INSERTED.NRPEDEXOL,
             INSERTED.CDMARCA,
             INSERTED.CDPRODUTO,
             INSERTED.DTPROGENPEOL,
             INSERTED.CDOPERBAIXA,
             INSERTED.DTBAIXTMPEOL,
             INSERTED.QTPROGENPEOL,
             INSERTED.IDBAIXENPEOL,
             INSERTED.IDBAIXAOLSAI,
             INSERTED.DTEFETENPEOL,
             INSERTED.QTEFETENPEOL,
             INSERTED.DTPROGEMBARQ,
             INSERTED.QTATENDPEDOL,
             INSERTED.VRPBRUTOPEDOL,
             INSERTED.IDITMPEDOLBLOQ,
             INSERTED.CDOPERBLOQITM,
             INSERTED.CDLOTENVITOL,
             INSERTED.CDOPERLOTEOL,
             INSERTED.IDITEMAJUSTE,
             INSERTED.VRPLIQUIPEDOL,
             INSERTED.CDPRODORIGPEDOL,
             INSERTED.QTORIGPRODPED,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_NEW_CDFILDEST,
                                 @V_NEW_CDFILLANC,
                                 @V_NEW_NRPEDEXOL,
                                 @V_NEW_CDMARCA,
                                 @V_NEW_CDPRODUTO,
                                 @V_NEW_DTPROGENPEOL,
                                 @V_NEW_CDOPERBAIXA,
                                 @V_NEW_DTBAIXTMPEOL,
                                 @V_NEW_QTPROGENPEOL,
                                 @V_NEW_IDBAIXENPEOL,
                                 @V_NEW_IDBAIXAOLSAI,
                                 @V_NEW_DTEFETENPEOL,
                                 @V_NEW_QTEFETENPEOL,
                                 @V_NEW_DTPROGEMBARQ,
                                 @V_NEW_QTATENDPEDOL,
                                 @V_NEW_VRPBRUTOPEDOL,
                                 @V_NEW_IDITMPEDOLBLOQ,
                                 @V_NEW_CDOPERBLOQITM,
                                 @V_NEW_CDLOTENVITOL,
                                 @V_NEW_CDOPERLOTEOL,
                                 @V_NEW_IDITEMAJUSTE,
                                 @V_NEW_VRPLIQUIPEDOL,
                                 @V_NEW_CDPRODORIGPEDOL,
                                 @V_NEW_QTORIGPRODPED,  
                                 @V_OLD_CDFILDEST,
                                 @V_OLD_CDFILLANC,
                                 @V_OLD_NRPEDEXOL,
                                 @V_OLD_CDMARCA,
                                 @V_OLD_CDPRODUTO,
                                 @V_OLD_DTPROGENPEOL,
                                 @V_OLD_CDOPERBAIXA,
                                 @V_OLD_DTBAIXTMPEOL,
                                 @V_OLD_QTPROGENPEOL,
                                 @V_OLD_IDBAIXENPEOL,
                                 @V_OLD_IDBAIXAOLSAI,
                                 @V_OLD_DTEFETENPEOL,
                                 @V_OLD_QTEFETENPEOL,
                                 @V_OLD_DTPROGEMBARQ,
                                 @V_OLD_QTATENDPEDOL,
                                 @V_OLD_VRPBRUTOPEDOL,
                                 @V_OLD_IDITMPEDOLBLOQ,
                                 @V_OLD_CDOPERBLOQITM,
                                 @V_OLD_CDLOTENVITOL,
                                 @V_OLD_CDOPERLOTEOL,
                                 @V_OLD_IDITEMAJUSTE,
                                 @V_OLD_VRPLIQUIPEDOL,
                                 @V_OLD_CDPRODORIGPEDOL,
                                 @V_OLD_QTORIGPRODPED;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO= 'D' /*DELETING*/ BEGIN
         IF @V_OLD_CDFILDEST IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Filial Dest.  '  + @V_OLD_CDFILDEST + ' ';
         END;
         IF @V_OLD_CDFILLANC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Filial Lan.  ' + @V_OLD_CDFILLANC + ' ';
         END;
         IF @V_OLD_NRPEDEXOL  IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Pedido  ' + @V_OLD_NRPEDEXOL  + ' ';
         END;
         IF @V_OLD_CDMARCA  IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Marca  ' + @V_OLD_CDMARCA  + ' ';
         END;
         IF @V_OLD_CDPRODUTO IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Produto'  + @V_OLD_CDPRODUTO + ' ';
         END;
         IF @V_OLD_DTPROGENPEOL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Dt. Entr. Pedido'  + CONVERT(VARCHAR, @V_OLD_DTPROGENPEOL) + ' ';
         END;
         IF @V_OLD_CDOPERBAIXA IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Oper. que Baixou' + @V_OLD_CDOPERBAIXA + ' ';
         END;
         IF @V_OLD_DTBAIXTMPEOL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Dt. Baixa'  + CONVERT(VARCHAR, @V_OLD_DTBAIXTMPEOL) + ' ';
         END;
         IF @V_OLD_QTPROGENPEOL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Qt. Itens'  + CONVERT(VARCHAR(5),ROUND(@V_OLD_QTPROGENPEOL, 3)) + ' ';
         END;
         IF @V_OLD_IDBAIXENPEOL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'ID Baixa' + @V_OLD_IDBAIXENPEOL + ' ';
         END;
         IF @V_OLD_IDBAIXAOLSAI IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'ID Sada' + @V_OLD_IDBAIXAOLSAI + ' ';
         END;
         IF @V_OLD_DTEFETENPEOL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Dt. Efetivao' + CONVERT(VARCHAR, @V_OLD_DTEFETENPEOL) + ' ';
         END;
         IF @V_OLD_QTEFETENPEOL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Qt. Efetiva' + CONVERT(VARCHAR(5),ROUND(@V_OLD_QTEFETENPEOL, 3)) + ' ';
         END;
         IF @V_OLD_DTPROGEMBARQ IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Dt. Embarque' + CONVERT(VARCHAR, @V_OLD_DTPROGEMBARQ) + ' ';
         END;
         IF @V_OLD_QTATENDPEDOL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Qt. para OL' + CONVERT(VARCHAR(5),ROUND(@V_OLD_QTATENDPEDOL, 3)) + ' ';
         END;
         IF @V_OLD_VRPBRUTOPEDOL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Peso Bruto' + CONVERT(VARCHAR,ROUND(@V_OLD_VRPBRUTOPEDOL, 3)) + ' ';
         END;
         IF @V_OLD_IDITMPEDOLBLOQ IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Item bloqueado:' + CONVERT(VARCHAR,ROUND(@V_OLD_IDITMPEDOLBLOQ, 3)) + ' ';
         END;
         IF @V_OLD_CDOPERBLOQITM IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Operador bloqueio:' + CONVERT(VARCHAR,ROUND(@V_OLD_CDOPERBLOQITM, 3)) + ' ';
         END;
         IF @V_OLD_CDLOTENVITOL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Lote:' + CONVERT(VARCHAR,ROUND(@V_OLD_CDLOTENVITOL, 3)) + ' ';
         END;
         IF @V_OLD_CDOPERLOTEOL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Operador lote:' + CONVERT(VARCHAR,ROUND(@V_OLD_CDOPERLOTEOL, 3)) + ' ';
         END;
         IF @V_OLD_IDITEMAJUSTE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Item Ajust:' + CONVERT(VARCHAR,ROUND(@V_OLD_IDITEMAJUSTE, 3)) + ' ';
         END;
         IF @V_OLD_VRPLIQUIPEDOL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Peso Lquido'  + CONVERT(VARCHAR,ROUND(@V_OLD_VRPLIQUIPEDOL, 3)) + ' ';
         END;
         IF @V_OLD_CDPRODORIGPEDOL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Prod. Orig.' + @V_OLD_CDPRODORIGPEDOL + ' ';
         END;
         IF @V_OLD_QTORIGPRODPED IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Qt. Orig.' + CONVERT(VARCHAR, ROUND(@V_OLD_QTORIGPRODPED, 3)) + ' ';
         END;

         SET @V_TIPO = '3';
         SET @V_ITPESQ = @V_OLD_CDFILDEST + @V_OLD_CDFILLANC + @V_OLD_NRPEDEXOL + @V_OLD_CDMARCA  + @V_OLD_CDPRODUTO + CONVERT(VARCHAR, @V_OLD_DTPROGENPEOL);
      END
      ELSE BEGIN
         IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
            IF (ISNULL(@V_OLD_CDFILDEST,'')         <>       ISNULL(@V_NEW_CDFILDEST,''))      OR
               (ISNULL(@V_OLD_CDFILLANC,'')         <>       ISNULL(@V_NEW_CDFILLANC,''))      OR
               (ISNULL(@V_OLD_NRPEDEXOL,'')         <>       ISNULL(@V_NEW_NRPEDEXOL,''))      OR
               (ISNULL(@V_OLD_CDMARCA ,'')          <>       ISNULL(@V_NEW_CDMARCA ,''))       OR
               (ISNULL(@V_OLD_CDPRODUTO,'')         <>       ISNULL(@V_NEW_CDPRODUTO,''))      OR
               (ISNULL(@V_OLD_DTPROGENPEOL,0)       <>       ISNULL(@V_NEW_DTPROGENPEOL,0))    OR
               (ISNULL(@V_OLD_CDOPERBAIXA,'')       <>       ISNULL(@V_NEW_CDOPERBAIXA,''))    OR
               (ISNULL(@V_OLD_DTBAIXTMPEOL,0)       <>       ISNULL(@V_NEW_DTBAIXTMPEOL,0))    OR
               (ISNULL(@V_OLD_QTPROGENPEOL,0)       <>       ISNULL(@V_NEW_QTPROGENPEOL,0))    OR
               (ISNULL(@V_OLD_IDBAIXENPEOL,'')      <>       ISNULL(@V_NEW_IDBAIXENPEOL,''))   OR
               (ISNULL(@V_OLD_IDBAIXAOLSAI,'')      <>       ISNULL(@V_NEW_IDBAIXAOLSAI,''))   OR
               (ISNULL(@V_OLD_DTEFETENPEOL,0)       <>       ISNULL(@V_NEW_DTEFETENPEOL,0))    OR
               (ISNULL(@V_OLD_QTEFETENPEOL,0)       <>       ISNULL(@V_NEW_QTEFETENPEOL,0))    OR
               (ISNULL(@V_OLD_DTPROGEMBARQ,0)       <>       ISNULL(@V_NEW_DTPROGEMBARQ,0))    OR
               (ISNULL(@V_OLD_QTATENDPEDOL,0)       <>       ISNULL(@V_NEW_QTATENDPEDOL,0))    OR
               (ISNULL(@V_OLD_VRPBRUTOPEDOL,0)      <>       ISNULL(@V_NEW_VRPBRUTOPEDOL,0))   OR
               (ISNULL(@V_OLD_IDITMPEDOLBLOQ,0)     <>       ISNULL(@V_NEW_IDITMPEDOLBLOQ,0))  OR
               (ISNULL(@V_OLD_CDOPERBLOQITM,0)      <>       ISNULL(@V_NEW_CDOPERBLOQITM,0))   OR
               (ISNULL(@V_OLD_CDLOTENVITOL,0)       <>       ISNULL(@V_NEW_CDLOTENVITOL,0))    OR
               (ISNULL(@V_OLD_CDOPERLOTEOL,0)       <>       ISNULL(@V_NEW_CDOPERLOTEOL,0))    OR
               (ISNULL(@V_OLD_IDITEMAJUSTE,0)       <>       ISNULL(@V_NEW_IDITEMAJUSTE,0))    OR
               (ISNULL(@V_OLD_VRPLIQUIPEDOL,0)      <>       ISNULL(@V_NEW_VRPLIQUIPEDOL,0))   BEGIN
               IF ISNULL(@V_OLD_CDFILDEST, '') <> ISNULL(@V_NEW_CDFILDEST, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Filial Dest.'  + @V_NEW_CDFILDEST + ' ';
               END;
               IF ISNULL(@V_OLD_CDFILLANC, '') <> ISNULL(@V_NEW_CDFILLANC, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Filial Lan.'  + @V_NEW_CDFILLANC + ' ';
               END;
               IF ISNULL(@V_OLD_NRPEDEXOL , '') <> ISNULL(@V_NEW_NRPEDEXOL , '') BEGIN
                  SET @V_DESC = @V_DESC + 'Pedido' + @V_NEW_NRPEDEXOL + ' ';
               END;
               IF ISNULL(@V_OLD_CDMARCA , '') <> ISNULL(@V_NEW_CDMARCA , '') BEGIN
                  SET @V_DESC = @V_DESC + 'Marca' + @V_NEW_CDMARCA  + ' ';
               END;
               IF ISNULL(@V_OLD_CDPRODUTO, '') <> ISNULL(@V_NEW_CDPRODUTO, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Produto' + @V_NEW_CDPRODUTO + ' ';
               END;
               IF ISNULL(@V_OLD_DTPROGENPEOL, '') <> ISNULL(@V_NEW_DTPROGENPEOL, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Dt. Entr. Pedido' + CONVERT(VARCHAR, @V_NEW_DTPROGENPEOL) + ' ';
               END;
               IF ISNULL(@V_OLD_CDOPERBAIXA, '') <> ISNULL(@V_NEW_CDOPERBAIXA, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Oper. que Baixou' + @V_NEW_CDOPERBAIXA + ' ';
               END;
               IF ISNULL(@V_OLD_DTBAIXTMPEOL, '') <> ISNULL(@V_NEW_DTBAIXTMPEOL, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Dt. Baixa'  + CONVERT(VARCHAR, @V_NEW_DTBAIXTMPEOL) + ' ';
               END;
               IF ISNULL(@V_OLD_QTPROGENPEOL, '') <> ISNULL(@V_NEW_QTPROGENPEOL, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Qt. Itens' + CONVERT(VARCHAR,ROUND(@V_NEW_QTPROGENPEOL, 3)) + ' ';
               END;
               IF ISNULL(@V_OLD_IDBAIXENPEOL, '') <> ISNULL(@V_NEW_IDBAIXENPEOL, '') BEGIN
                  SET @V_DESC = @V_DESC + 'ID Baixa'  + @V_NEW_IDBAIXENPEOL + ' ';
               END;
               IF ISNULL(@V_OLD_IDBAIXAOLSAI, '') <> ISNULL(@V_NEW_IDBAIXAOLSAI, '') BEGIN
                  SET @V_DESC = @V_DESC + 'ID Sada' + @V_NEW_IDBAIXAOLSAI + ' ';
               END;
               IF ISNULL(@V_OLD_DTEFETENPEOL, '') <> ISNULL(@V_NEW_DTEFETENPEOL, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Dt. Efetivao' + CONVERT(VARCHAR, @V_NEW_DTEFETENPEOL) + ' ';
               END;
               IF ISNULL(@V_OLD_QTEFETENPEOL, '') <> ISNULL(@V_NEW_QTEFETENPEOL, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Qt. Efetiva' + CONVERT(VARCHAR,ROUND(@V_NEW_QTEFETENPEOL, 3)) + ' ';
               END;
               IF ISNULL(@V_OLD_DTPROGEMBARQ, '') <> ISNULL(@V_NEW_DTPROGEMBARQ, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Dt. Embarque' + CONVERT(VARCHAR, @V_NEW_DTPROGEMBARQ) + ' ';
               END;
               IF ISNULL(@V_OLD_QTATENDPEDOL, '') <> ISNULL(@V_NEW_QTATENDPEDOL, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Qt. para OL' + CONVERT(VARCHAR,ROUND(@V_NEW_QTATENDPEDOL, 3)) + ' ';
               END;
               IF ISNULL(@V_OLD_VRPBRUTOPEDOL, '') <> ISNULL(@V_NEW_VRPBRUTOPEDOL, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Peso Bruto' + CONVERT(VARCHAR,ROUND(@V_NEW_VRPBRUTOPEDOL, 3)) + ' ';
               END;

               IF ISNULL(@V_OLD_IDITMPEDOLBLOQ, '') <> ISNULL(@V_NEW_IDITMPEDOLBLOQ, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Item bloqueado:' + CONVERT(VARCHAR,ROUND(@V_NEW_IDITMPEDOLBLOQ, 3)) + ' ';
               END;
               IF ISNULL(@V_OLD_CDOPERBLOQITM, '') <> ISNULL(@V_NEW_CDOPERBLOQITM, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Operador bloqueio:' + CONVERT(VARCHAR,ROUND(@V_NEW_CDOPERBLOQITM, 3)) + ' ';
               END;
               IF ISNULL(@V_OLD_CDLOTENVITOL, '') <> ISNULL(@V_NEW_CDLOTENVITOL, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Lote:' + CONVERT(VARCHAR,ROUND(@V_NEW_CDLOTENVITOL, 3)) + ' ';
               END;
               IF ISNULL(@V_OLD_CDOPERLOTEOL, '') <> ISNULL(@V_NEW_CDOPERLOTEOL, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Operador lote:' + CONVERT(VARCHAR,ROUND(@V_NEW_CDOPERLOTEOL, 3)) + ' ';
               END;
               IF ISNULL(@V_OLD_IDITEMAJUSTE, '') <> ISNULL(@V_NEW_IDITEMAJUSTE, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Item Ajust:' + CONVERT(VARCHAR,ROUND(@V_NEW_IDITEMAJUSTE, 3)) + ' ';
               END;

               IF ISNULL(@V_OLD_VRPLIQUIPEDOL, '') <> ISNULL(@V_NEW_VRPLIQUIPEDOL, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Peso Lquido'  + CONVERT(VARCHAR,ROUND(@V_NEW_VRPLIQUIPEDOL, 3)) + ' ';
               END;
               IF @V_OLD_CDPRODORIGPEDOL <> @V_NEW_CDPRODORIGPEDOL BEGIN
                  SET @V_DESC = @V_DESC + 'Prod. Orig.' + @V_NEW_CDPRODORIGPEDOL + ' ';
               END;
               IF @V_OLD_QTORIGPRODPED <> @V_NEW_QTORIGPRODPED BEGIN
                  SET @V_DESC = @V_DESC + 'Qt. Orig.' + CONVERT(VARCHAR, ROUND(@V_NEW_QTORIGPRODPED, 3)) + ' ';
               END;

               SET  @V_TIPO   = '2';
               SET  @V_ITPESQ = @V_NEW_CDFILDEST + @V_NEW_CDFILLANC + @V_NEW_NRPEDEXOL + @V_NEW_CDMARCA  + @V_NEW_CDPRODUTO + CONVERT(VARCHAR, @V_NEW_DTPROGENPEOL);
            END;
         END
         ELSE BEGIN
            IF @V_NEW_CDFILDEST IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Filial Dest.'  + @V_NEW_CDFILDEST + ' ';
            END;
            IF @V_NEW_CDFILLANC IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Filial Lan.' + @V_NEW_CDFILLANC + ' ';
            END;
            IF @V_NEW_NRPEDEXOL  IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Pedido' + @V_NEW_NRPEDEXOL + ' ';
            END;
            IF @V_NEW_CDMARCA  IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Marca' + @V_NEW_CDMARCA  + ' ';
            END;
            IF @V_NEW_CDPRODUTO IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Produto'  + @V_NEW_CDPRODUTO + ' ';
            END;
            IF @V_NEW_DTPROGENPEOL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Dt. Entr. Pedido'  + CONVERT(VARCHAR, @V_NEW_DTPROGENPEOL) + ' ';
            END;
            IF @V_NEW_CDOPERBAIXA IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Oper. que Baixou' + @V_NEW_CDOPERBAIXA + ' ';
            END;
            IF @V_NEW_DTBAIXTMPEOL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Dt. Baixa'  + CONVERT(VARCHAR, @V_NEW_DTPROGENPEOL) + ' ';
            END;
            IF @V_NEW_QTPROGENPEOL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Qt. Itens'  + CONVERT(VARCHAR,ROUND(@V_NEW_QTPROGENPEOL, 3)) + ' ';
            END;
            IF @V_NEW_IDBAIXENPEOL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'ID Baixa' + @V_NEW_IDBAIXENPEOL + ' ';
            END;
            IF @V_NEW_IDBAIXAOLSAI IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'ID Sada' + @V_NEW_IDBAIXAOLSAI + ' ';
            END;
            IF @V_NEW_DTEFETENPEOL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Dt. Efetivao' + CONVERT(VARCHAR, @V_NEW_DTPROGENPEOL) + ' ';
            END;
            IF @V_NEW_QTEFETENPEOL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Qt. Efetiva' + CONVERT(VARCHAR,ROUND(@V_NEW_QTEFETENPEOL, 3)) + ' ';
            END;
            IF @V_NEW_DTPROGEMBARQ IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Dt. Embarque' + CONVERT(VARCHAR, @V_NEW_DTPROGEMBARQ) + ' ';
            END;
            IF @V_NEW_QTATENDPEDOL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Qt. para OL' + CONVERT(VARCHAR,ROUND(@V_NEW_QTATENDPEDOL, 3)) + ' ';
            END;
            IF @V_NEW_VRPBRUTOPEDOL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Peso Bruto' + CONVERT(VARCHAR,ROUND(@V_NEW_VRPBRUTOPEDOL, 3)) + ' ';
            END;

            IF @V_NEW_IDITMPEDOLBLOQ IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Item bloqueado:' + CONVERT(VARCHAR,ROUND(@V_NEW_IDITMPEDOLBLOQ, 3)) + ' ';
            END;
            IF @V_NEW_CDOPERBLOQITM IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Operador bloqueio:' + CONVERT(VARCHAR,ROUND(@V_NEW_CDOPERBLOQITM, 3)) + ' ';
            END;
            IF @V_NEW_CDLOTENVITOL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Lote:' + CONVERT(VARCHAR,ROUND(@V_NEW_CDLOTENVITOL, 3)) + ' ';
            END;
            IF @V_NEW_CDOPERLOTEOL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Operador lote:' + CONVERT(VARCHAR,ROUND(@V_NEW_CDOPERLOTEOL, 3)) + ' ';
            END;
            IF @V_NEW_IDITEMAJUSTE IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Item Ajust:' + CONVERT(VARCHAR,ROUND(@V_NEW_IDITEMAJUSTE, 3)) + ' ';
            END;

            IF @V_NEW_VRPLIQUIPEDOL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Peso Lquido' + CONVERT(VARCHAR,ROUND(@V_NEW_VRPLIQUIPEDOL, 3)) + ' ';
            END;
            IF @V_NEW_CDPRODORIGPEDOL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Prod. Orig.' + @V_NEW_CDPRODORIGPEDOL + ' ';
            END;
            IF @V_NEW_QTORIGPRODPED IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Qt. Orig.' + CONVERT(VARCHAR, ROUND(@V_NEW_QTORIGPRODPED, 3)) + ' ';
            END;

            SET  @V_TIPO   = '1';
            SET  @V_ITPESQ = @V_NEW_CDFILDEST + @V_NEW_CDFILLANC + @V_NEW_NRPEDEXOL + @V_NEW_CDMARCA  + @V_NEW_CDPRODUTO + CONVERT(VARCHAR, @V_NEW_DTPROGENPEOL);
         END;
      END;
      EXEC NMUSUARIO @V_USUARIO;
      SET @V_USUARIO = ISNULL(@V_USUARIO, ' ');
      IF (@V_TIPO <> '0')  BEGIN
         IF @V_DESC IS NOT NULL BEGIN
            IF @V_USUARIO IS NOT NULL BEGIN
               SET  @V_DTOPER = GETDATE();
               SET  @V_DESC = SUBSTRING(@V_DESC, 1, 300);
                  INSERT INTO LOGOPERA
                             (NMTABELA, DTOPERACAO, NMRESPOPER,
                              IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER)
                         VALUES
                             ('ITEMPEDEXOL', @V_DTOPER, @V_USUARIO,
                              @V_TIPO, @V_ITPESQ, @V_DESC, @V_NEW_CDFILLANC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_NEW_CDFILDEST,
                                 @V_NEW_CDFILLANC,
                                 @V_NEW_NRPEDEXOL,
                                 @V_NEW_CDMARCA,
                                 @V_NEW_CDPRODUTO,
                                 @V_NEW_DTPROGENPEOL,
                                 @V_NEW_CDOPERBAIXA,
                                 @V_NEW_DTBAIXTMPEOL,
                                 @V_NEW_QTPROGENPEOL,
                                 @V_NEW_IDBAIXENPEOL,
                                 @V_NEW_IDBAIXAOLSAI,
                                 @V_NEW_DTEFETENPEOL,
                                 @V_NEW_QTEFETENPEOL,
                                 @V_NEW_DTPROGEMBARQ,
                                 @V_NEW_QTATENDPEDOL,
                                 @V_NEW_VRPBRUTOPEDOL,
                                 @V_NEW_IDITMPEDOLBLOQ,
                                 @V_NEW_CDOPERBLOQITM,
                                 @V_NEW_CDLOTENVITOL,
                                 @V_NEW_CDOPERLOTEOL,
                                 @V_NEW_IDITEMAJUSTE,
                                 @V_NEW_VRPLIQUIPEDOL,
                                 @V_NEW_CDPRODORIGPEDOL,
                                 @V_NEW_QTORIGPRODPED,
                                 @V_OLD_CDFILDEST,
                                 @V_OLD_CDFILLANC,
                                 @V_OLD_NRPEDEXOL,
                                 @V_OLD_CDMARCA,
                                 @V_OLD_CDPRODUTO,
                                 @V_OLD_DTPROGENPEOL,
                                 @V_OLD_CDOPERBAIXA,
                                 @V_OLD_DTBAIXTMPEOL,
                                 @V_OLD_QTPROGENPEOL,
                                 @V_OLD_IDBAIXENPEOL,
                                 @V_OLD_IDBAIXAOLSAI,
                                 @V_OLD_DTEFETENPEOL,
                                 @V_OLD_QTEFETENPEOL,
                                 @V_OLD_DTPROGEMBARQ,
                                 @V_OLD_QTATENDPEDOL,
                                 @V_OLD_VRPBRUTOPEDOL,
                                 @V_OLD_IDITMPEDOLBLOQ,
                                 @V_OLD_CDOPERBLOQITM,
                                 @V_OLD_CDLOTENVITOL,
                                 @V_OLD_CDOPERLOTEOL,
                                 @V_OLD_IDITEMAJUSTE,
                                 @V_OLD_VRPLIQUIPEDOL,
                                 @V_OLD_CDPRODORIGPEDOL,
                                 @V_OLD_QTORIGPRODPED;

   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_SUP_ITEMPEDEXOL','5.05.012';
GO

