CREATE TABLE TOTALDIACAIXA(
   CDFILIAL VARCHAR2(04) NOT NULL,
   CDCAIXA VARCHAR2(03) NOT NULL,
   DTTOTAL DATE NOT NULL,
   VRGTINI  NUMBER, 
   VRGTFIN NUMBER,
   IDIMPTOTDIACAIXA VARCHAR2(01) DEFAULT 'N' NOT NULL,
   NRORG NUMBER DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
   IDATIVO VARCHAR2(1) DEFAULT 'S' NOT NULL
		CONSTRAINT CKC_IDATIVO_TOTALDIACAIXA CHECK (IDATIVO IN ('S', 'N')),
   DTINCLUSAO DATE NULL,
   DTULTATU DATE NULL,
   NRORGINCLUSAO NUMBER DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
   CDOPERINCLUSAO VARCHAR2(12) DEFAULT '1' NULL,
   NRORGULTATU NUMBER DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')	NULL,
   CDOPERULTATU VARCHAR2(12) DEFAULT '1' NULL,
		CONSTRAINT PK_TOTALDIACAIXA PRIMARY KEY (CDFILIAL, CDCAIXA, DTTOTAL)
)
/

CREATE INDEX VND00802_FK ON TOTALDIACAIXA (CDFILIAL ASC)
/

ALTER TABLE TOTALDIACAIXA ADD CONSTRAINT FKVND00802TOTALDIACAIXA_FILI FOREIGN KEY (CDFILIAL)
   REFERENCES FILIAL (CDFILIAL)
/

CREATE INDEX VND00803_FK ON TOTALDIACAIXA (CDFILIAL ASC, CDCAIXA ASC)
/

ALTER TABLE TOTALDIACAIXA ADD CONSTRAINT FKVND00803TOTALDIACAIXA_CAIXA FOREIGN KEY (CDFILIAL, CDCAIXA)
   REFERENCES CAIXA (CDFILIAL, CDCAIXA)
/

ALTER TABLE TOTALDIACAIXA ADD CONSTRAINT CKC_TOTALDIACAIXA_IDIMPTOT CHECK (IDIMPTOTDIACAIXA IN ('S', 'N'))
/